// AllSymbolsCombinations.c
// Alain Brobecker, september 2012
#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define TRUE 1
#define FALSE 0

#define MaxNbOfDifferentSymbols 6
#define MaxWidth 6
#define MaxHeight 6

int NbOfDifferentSymbols,Width,Height;
int NbCells,NbOccurrenceOfEachSymbol; //depends on the three above
char LinearGrid[MaxWidth*MaxHeight];
int NbGrids;


//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}


//*******************
//*******************
//****           ****
//**** ALL GRIDS ****
//****           ****
//*******************
//*******************


//**** SHOWLINEARGRID ****
void ShowLinearGrid() {
  int x,y;
  for(y=0;y<Height;y++) {
    for(x=0;x<Width;x++) {
      printf("%c",'A'+LinearGrid[y*Width+x]);
    }
//!!!    printf("\n");
    if(y<Height-1) { printf("/"); }
  }
  printf("\n");
}



//**** LOOP FUNCTION TO GENERATE ALL GRIDS ****
//Symbol must be !=0
void LoopFunction(int Symbol,int SymbolIndex,int Start,int End) {
  int n,c,position;
  for(n=Start;n<End;n++) {
    //Put the symbol at the nth empty position
    position=-1;
    c=-1;
    do {
      position++;
      if(LinearGrid[position]==0) {
        c++;
      }
    } while (c!=n);
    LinearGrid[position]=Symbol;
    if(SymbolIndex+1<NbOccurrenceOfEachSymbol) {
      //Next occurence of this symbol, after the one we have just put
      //(otherwise we would have duplicates)
      LoopFunction(Symbol,SymbolIndex+1,n,End);
    } else {
      if(Symbol+1<NbOfDifferentSymbols) {
        //Next Symbol
        LoopFunction(Symbol+1,0,0,NbCells-NbOccurrenceOfEachSymbol*(Symbol+1)+1);
      } else {
        //It was last Symbol, grid is complete
        //So process this grid
        NbGrids++;
        ShowLinearGrid();
      }
    }
    LinearGrid[position]=0;
  }
}

//**** MAIN *****************************************************************
int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); // no buffering for output!
  int c;

  //Read from command line
  if(argc<=3) { printf("Usage: AllSymbolCombinations Width Height NbOfDifferentSymbols\n"); exit(1); }
  Width=ReadNumber(argv[1]);
  Height=ReadNumber(argv[2]);
  NbOfDifferentSymbols=ReadNumber(argv[3]);
  //Depends of the above
  NbCells=Width*Height;
  if((NbCells%NbOfDifferentSymbols)!=0) {
    printf("%d*%d must be a multiple of %d\n",Width,Height,NbOfDifferentSymbols);
    exit(-1);
  }
  NbOccurrenceOfEachSymbol=NbCells/NbOfDifferentSymbols;
  printf("%d*%d=%d, %d symbols, %d times each\n",Width,Height,NbCells,NbOfDifferentSymbols,NbOccurrenceOfEachSymbol);

  for(c=0;c<NbCells;c++) { LinearGrid[c]=0; }
  NbGrids=0;
  LoopFunction(1,0,0,NbCells-NbOccurrenceOfEachSymbol+1);
//  printf("%d\n",NbCells-NbOccurrenceOfEachSymbol);
  printf("NbGrids=%d\n",NbGrids);

  exit(0);
}

