/* MotsAlphabtiques.c - Alain Brobecker, 2009/10/20 */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define FALSE           0
#define TRUE            1
#define MinLength       2

/**** SearchNext routine, brute force version ******************************/
/* To speed up this routine, copy beforehand the string to search at the   */
/* end of the text (you must allocate a bit more memory) and remove the    */
/* TextPos+StringLength<=TextLength condition in main loop. The routine    */
/* will always find a string, once this is done, compare Pos+Length and    */
/* return -1 if it is the one we added!                                    */
int SearchNext(char *String,int StringLength,char *Text,int TextLength,int TextPos) {
  int NbMatch=0;
  while((NbMatch<StringLength) && (TextPos+StringLength<=TextLength)) {
    if(Text[TextPos+NbMatch]==String[NbMatch]) {
      NbMatch++;
    } else {
      NbMatch=0;
      TextPos++;
    }
  }
  if(NbMatch==StringLength) {
    return(TextPos);
  } else {
    return(-1);
  }
}

int main(argc,argv) int argc; char *argv[]; {
  FILE *filep;
  char *Text, c;
  int TextLen,TextPos,TextPos2,Heterogram;
  int LettersUsed,shift;
  int WordLen,NextPos;
  int k;

  setbuf(stdout, NULL); /* no buffering for output! */
  
  if(argc!=2) { printf("usage: %s TextFile\n",argv[0]); exit(1); }

  /* get length of TextFile, allocate memory and load it */
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); TextLen=(int) ftell(filep); fseek(filep,0,0);
  Text=(char *) malloc((unsigned int) TextLen+2);
  fread(Text+1,1,TextLen,filep);
  TextLen+=2;
  Text[0]=' ';
  Text[TextLen-1]=' ';
  fclose(filep);
  
  /* convert uppercase to lowercase, and remove accents*/
  for(TextPos=0;TextPos<TextLen;TextPos++) {
    c=Text[TextPos];
    if((c>='A') && (c<='Z')) { c=c-'A'+'a'; }
    switch(c) {
      case '':case '':case '':case '':case '':case '':c='a';break;
      case '':case '':case '':case '':c='e';break;
      case '':case '':case '':case '':c='o';break;
      case '':case '':case '':case '':case '':case '':c='o';break;
      case '':case '':case '':case '':c='u';break;
      case '':case '':c='y';break;
      case '':c='c';break;
      case '':c='n';break;
    }
    if((c<'a') || (c>'z')) { c=' '; }
    Text[TextPos]=c;
  }
  
  /* Search for 'mots htrogrammes' */
  TextPos=0;
  while(TextPos<TextLen) {
    if(Text[TextPos]==' ') {
      TextPos++;
    } else {
      /* read word and look if it's an heterogram, else skip it */
      TextPos2=TextPos;
      Heterogram=TRUE;
      LettersUsed=0;
      while((Heterogram==TRUE) && (Text[TextPos2]!=' ')) {
//        printf("%c",Text[TextPos2]);
        shift=Text[TextPos2]-'a';
        if((LettersUsed & (1<<shift))!=0) {
          Heterogram=FALSE;
        } else {
          LettersUsed+=1<<shift;
        }
        TextPos2++;
      }
      /* heterogram, then print it */
      if((Heterogram==TRUE) && (TextPos2-TextPos>=MinLength-1)) {
        TextPos2=TextPos;
        while(Text[TextPos2]!=' ') {
          printf("%c",Text[TextPos2]);
          TextPos2++;
        }
        WordLen=TextPos2-TextPos;
        printf(";%d\n",WordLen);
        /* Now search all identical words (with spaces around) and kill them */
        NextPos=SearchNext(Text+TextPos-1,WordLen+2,Text,TextLen,TextPos2);
        while(NextPos!=-1) {
          for(k=0;k<WordLen;k++) { Text[NextPos+1+k]=' '; }
          NextPos=SearchNext(Text+TextPos-1,WordLen+2,Text,TextLen,NextPos+WordLen);
        }
      }
      /* skip word */
      while(Text[TextPos]!=' ') { TextPos++; }
    }
  }
  exit(0);
}
