//2019/05/22 - SearchMissingBlocksBetweenFiles.c - Alain Brobecker
#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define TRUE 1
#define FALSE 0



//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}


/**** Main *****************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); // no buffering for output!

  FILE *filep;
  unsigned char *File1,*File2;
  int File1Len,File2Len;
  int NbBlocksInFile1,NbBlocksInFile2,TrailingChars1,TrailingChars2;
  int SizeOfOneBlock;
  int IndexFile1,IndexFile2,BlockFoundInOtherFile,SimilarBlocks,t;
  int NbBlocksOnlyInFile1,NbBlocksOnlyInFile2;

  if(argc!=4) { printf("Usage: %s SizeOfOneBlock File1 File2\n",argv[0]); exit(1); }

  //**** Get Size Of Blocks ****
  SizeOfOneBlock=ReadNumber(argv[1]);
  if(SizeOfOneBlock<=0) { printf("Error: %s should be a >0 number\n",argv[1]); printf("Usage: %s SizeOfOneBlock File1 File2\n",argv[0]); exit(1); }

  //**** Load File1 ****
  filep=fopen(argv[2],"rb");
  if(filep==0) { printf("Error: %s not found\n",argv[2]); printf("Usage: %s SizeOfOneBlock File1 File2\n",argv[0]); exit(1); }
  fseek(filep,0,2); // 2 for EOF
  File1Len=(int) ftell(filep);
  fseek(filep,0,0); // 0 for SOF
  File1=(unsigned char *) malloc((unsigned int) File1Len+SizeOfOneBlock);
  fread(File1,1,File1Len,filep);
  fclose(filep);
  NbBlocksInFile1=File1Len/SizeOfOneBlock;
  TrailingChars1=File1Len%SizeOfOneBlock;
  printf("%s: %d blocks of %d chars",argv[2],NbBlocksInFile1,SizeOfOneBlock);
  if(TrailingChars1!=0) {
    printf(" (and %d trailing chars)",TrailingChars1);
  }
  printf("\n");

  //**** Load File2 ****
  filep=fopen(argv[3],"rb");
  if(filep==0) { printf("Error: %s not found\n",argv[3]); printf("Usage: %s SizeOfOneBlock File2 File2\n",argv[0]); exit(1); }
  fseek(filep,0,2); // 2 for EOF
  File2Len=(int) ftell(filep);
  fseek(filep,0,0); // 0 for SOF
  File2=(unsigned char *) malloc((unsigned int) File2Len+SizeOfOneBlock);
  fread(File2,1,File2Len,filep);
  fclose(filep);
  NbBlocksInFile2=File2Len/SizeOfOneBlock;
  TrailingChars2=File2Len%SizeOfOneBlock;
  printf("%s: %d blocks of %d chars",argv[3],NbBlocksInFile2,SizeOfOneBlock);
  if(TrailingChars2!=0) {
    printf(" (and %d trailing chars)",TrailingChars2);
  }
  printf("\n\n");

  //Search blocks that are only in File1
  NbBlocksOnlyInFile1=0;
  for(IndexFile1=0;IndexFile1<NbBlocksInFile1;IndexFile1++) {
    BlockFoundInOtherFile=FALSE;
    IndexFile2=0;
    while((IndexFile2<NbBlocksInFile2) && (BlockFoundInOtherFile==FALSE)) {
      SimilarBlocks=TRUE;
      t=0;
      while((t<SizeOfOneBlock) && (SimilarBlocks==TRUE)) {
        if(File1[IndexFile1*SizeOfOneBlock+t]!=File2[IndexFile2*SizeOfOneBlock+t]) { SimilarBlocks=FALSE; }
        t++;
      }
      if(SimilarBlocks==TRUE) {
        BlockFoundInOtherFile=TRUE;
      }
      IndexFile2++;
    }
    if(BlockFoundInOtherFile==FALSE) {
      if(NbBlocksOnlyInFile1<10) {
        printf("%s:%d not found in %s -> ",argv[2],IndexFile1*SizeOfOneBlock,argv[3]);
        for(t=0;t<SizeOfOneBlock;t++) {
          printf("%c",File1[IndexFile1*SizeOfOneBlock+t]);
        }
        printf("\n");
      }
      if(NbBlocksOnlyInFile1==10) { printf("...\n"); }
      NbBlocksOnlyInFile1++;
    }
  }
  printf("\n%d blocks only in %s\n\n",NbBlocksOnlyInFile1,argv[2]);

  //Search blocks that are only in File2
  NbBlocksOnlyInFile2=0;
  for(IndexFile2=0;IndexFile2<NbBlocksInFile2;IndexFile2++) {
    BlockFoundInOtherFile=FALSE;
    IndexFile1=0;
    while((IndexFile1<NbBlocksInFile1) && (BlockFoundInOtherFile==FALSE)) {
      SimilarBlocks=TRUE;
      t=0;
      while((t<SizeOfOneBlock) && (SimilarBlocks==TRUE)) {
        if(File2[IndexFile2*SizeOfOneBlock+t]!=File1[IndexFile1*SizeOfOneBlock+t]) { SimilarBlocks=FALSE; }
        t++;
      }
      if(SimilarBlocks==TRUE) {
        BlockFoundInOtherFile=TRUE;
      }
      IndexFile1++;
    }
    if(BlockFoundInOtherFile==FALSE) {
      if(NbBlocksOnlyInFile2<10) {
        printf("%s:%d not found in %s -> ",argv[3],IndexFile2*SizeOfOneBlock,argv[2]);
        for(t=0;t<SizeOfOneBlock;t++) {
          printf("%c",File2[IndexFile2*SizeOfOneBlock+t]);
        }
        printf("\n");
      }
      if(NbBlocksOnlyInFile2==10) { printf("...\n"); }
      NbBlocksOnlyInFile2++;
    }
  }
  printf("\n%d blocks only in %s\n\n",NbBlocksOnlyInFile2,argv[3]);
 exit(0);
}
