// Alain Brobecker, 2010/04/15

/*
* Trouver un entier suprieur  1 qui est la somme des cubes de ses chiffres (quatre solutions). 153;370;371;407
  Trouver l'unique entier de six chiffres qui est la somme des puissances siximes de ses chiffres. 548834
  Trouver l'unique entier de huit chiffres qui est la somme des puissances septimes de ses chiffres. 1741725
* Trouver l'unique entier suprieur  1 qui est le carr de la somme de ses chiffres. 81
  Trouver l'unique entier de trois chiffres qui est le cube de la somme de ses chiffres. 512
  Trouver l'unique entier de quatre chiffres qui est la puissance quatrime de la somme de ses chiffres. 2401
  Trouver l'unique entier qui est la puissance sixime de la somme de ses chiffres. (?) 34012224
* Trouver l'unique entier non nul qui est le double de la somme de ses chiffres. 18
  Trouver l'unique entier non nul qui est le triple de la somme de ses chiffres. 27
  Trouver l'unique entier non nul qui est le quintuple de la somme de ses chiffres. 45
  Trouver l'unique entier non nul qui est le sextuple de la somme de ses chiffres. 54
  Trouver l'unique entier non nul qui est l'octuple de la somme de ses chiffres. 72
  Trouver l'unique entier non nul qui est le nonuple de la somme de ses chiffres. 81
  Trouver l'unique entier non nul qui est gal  11 fois la somme de ses chiffres.
  Trouver l'unique entier non nul qui est gal  12 fois la somme de ses chiffres.
  Trouver l'unique entier non nul qui est gal  14 fois la somme de ses chiffres.
  Trouver l'unique entier non nul qui est gal  15 fois la somme de ses chiffres.
  Trouver l'unique entier non nul qui est gal  17 fois la somme de ses chiffres.
  Trouver l'unique entier non nul qui est gal  18 fois la somme de ses chiffres.
  Trouver l'unique entier non nul qui est gal  20 fois la somme de ses chiffres.
* Trouver l'unique entier non nul qui est le double du produit de ses chiffres.
  Trouver l'unique entier non nul qui est le quadruple du produit de ses chiffres.
  Trouver l'unique entier non nul qui est le quintuple du produit de ses chiffres.
  Trouver l'unique entier non nul qui est le sextuple du produit de ses chiffres.
  Trouver l'unique entier non nul qui est le septuple du produit de ses chiffres.
  Trouver l'unique entier non nul qui est gal  11 fois le produit de ses chiffres.
  Trouver l'unique entier non nul qui est gal  14 fois le produit de ses chiffres.
  Trouver l'unique entier non nul qui est gal  17 fois le produit de ses chiffres.
*/

/*
somme des puissances
  1=1^N
  X=X^1 pour X dans [1;9]
  153=1^3+5^3+3^3
  370=3^3+7^3+0^3
  371=3^3+7^3+1^3
  407=4^3+0^3+7^3
  1634=1^4+6^4+3^4+4^4
  4150=4^5+1^5+5^5+0^5
  4151=4^5+1^5+5^5+1^5
  8208=8^4+2^4+0^4+8^4
  9474=9^4+4^4+7^4+4^4
  54748=5^5+4^5+7^5+4^5+8^5
  92727=9^5+2^5+7^5+2^5+7^5
  93084=9^5+3^5+0^5+8^5+4^5
  194979=1^5+9^5+4^5+9^5+7^5+9^5
  548834=5^6+4^6+8^6+8^6+3^6+4^6
  1741725=1^7+7^7+4^7+1^7+7^7+2^7+5^7
  4210818=4^7+2^7+1^7+0^7+8^7+1^7+8^7
  9800817=9^7+8^7+0^7+0^7+8^7+1^7+7^7
  9926315=9^7+9^7+2^7+6^7+3^7+1^7+5^7
  14459929=1^7+4^7+4^7+5^7+9^7+9^7+2^7+9^7
  24678050=2^8+4^8+6^8+7^8+8^8+0^8+5^8+0^8
  24678051=2^8+4^8+6^8+7^8+8^8+0^8+5^8+1^8
  88593477=8^8+8^8+5^8+9^8+3^8+4^8+7^8+7^8
puissance du produit
  1=1^N
  X=X^1 pour X dans [1;9]
puissance de la somme
  1=1^N
  X=X^1 pour X dans [1;9]
  81=(8+1)^2
  512=(5+1+2)^3
  2401=(2+4+0+1)^4
  4913=(4+9+1+3)^3
  5832=(5+8+3+2)^3
  17576=(1+7+5+7+6)^3
  19683=(1+9+6+8+3)^3
  234256=(2+3+4+2+5+6)^4
  390625=(3+9+0+6+2+5)^4
  614656=(6+1+4+6+5+6)^4
  1679616=(1+6+7+9+6+1+6)^4
  17210368=(1+7+2+1+0+3+6+8)^5
  34012224=(3+4+0+1+2+2+2+4)^6
  52521875=(5+2+5+2+1+8+7+5)^5
  60466176=(6+0+4+6+6+1+7+6)^5
multiple du produit
  X=X*1 pour X dans [1;9]
  11=(1*1)*11
  12=(1*2)*6
  15=(1*5)*3
  24=(2*4)*3
  36=(3*6)*2
  128=(1*2*8)*8
  135=(1*3*5)*9
  144=(1*4*4)*9
  175=(1*7*5)*5
  216=(2*1*6)*18
  224=(2*2*4)*14
  384=(3*8*4)*4
  432=(4*3*2)*18
  624=(6*2*4)*13
  672=(6*7*2)*8
  735=(7*3*5)*7
  816=(8*1*6)*17
  1197=(1*1*9*7)*19
  1296=(1*2*9*6)*12
  1575=(1*5*7*5)*9
  3276=(3*2*7*6)*13
  12768=(1*2*7*6*8)*19
  34992=(3*4*9*9*2)*18
  139968=(1*3*9*9*6*8)*12
  1886976=(1*8*8*6*9*7*6)*13
multiple de la somme
  X=X*1 pour X dans [1;9]
  18=(1+8)*2
  27=(2+7)*3
  12=(1+2)*4
  24=(2+4)*4
  36=(3+6)*4
  48=(4+8)*4
  45=(4+5)*5
  54=(5+4)*6
  72=(7+2)*8
  21=(2+1)*7
  42=(4+2)*7
  63=(6+3)*7
  84=(8+4)*7
  81=(8+1)*9
  10=(1+0)*10
  20=(2+0)*10
  30=(3+0)*10
  40=(4+0)*10
  50=(5+0)*10
  60=(6+0)*10
  70=(7+0)*10
  80=(8+0)*10
  90=(9+0)*10
  108=(1+0+8)*12
  114=(1+1+4)*19
  117=(1+1+7)*13
  126=(1+2+6)*14
  133=(1+3+3)*19
  135=(1+3+5)*15
  144=(1+4+4)*16
  152=(1+5+2)*19
  153=(1+5+3)*17
  156=(1+5+6)*13
  162=(1+6+2)*18
  171=(1+7+1)*19
  180=(1+8+0)*20
  190=(1+9+0)*19
  192=(1+9+2)*16
  195=(1+9+5)*13
  198=(1+9+8)*11
  209=(2+0+9)*19
  228=(2+2+8)*19
  247=(2+4+7)*19
  266=(2+6+6)*19
  285=(2+8+5)*19
  288=(2+8+8)*16
  399=(3+9+9)*19
*/


#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define base 10
#define nbmax 99999999

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */
  long long int Chiffre[20],PuissanceDuChiffre[20];
  long long int c,d,nb,nbdeChiffres;
  long long int SommeDesChiffres,ProduitDesChiffres;
  long long int PuissanceSommeDesChiffres,PuissanceProduitDesChiffres;
  long long int MultipleSommeDesChiffres,MultipleProduitDesChiffres;
  long long int SommeDesPuissances;

  for(nb=1;nb<nbmax;nb++) {
    //Isole les Chiffres
    d=nb;
    SommeDesChiffres=0;
    ProduitDesChiffres=1;
    c=0;
    while(d!=0) {
      Chiffre[c]=d%base;
      d=d/base;
      SommeDesChiffres+=Chiffre[c];
      ProduitDesChiffres*=Chiffre[c];
      c++;
    }
    nbdeChiffres=c;

    //**** Le nombre est gal  une puissance/un multiple de la somme/du produit des chiffres? ****
    PuissanceSommeDesChiffres=SommeDesChiffres;
    PuissanceProduitDesChiffres=ProduitDesChiffres;
    MultipleSommeDesChiffres=SommeDesChiffres;
    MultipleProduitDesChiffres=ProduitDesChiffres;
    for(d=1;d<21;d++) {

      // Un nombre est gal  une puissance de la somme de ses chiffres?
      // 81=(8+1)^2
      // 512=(5+1+2)^3
      if(nb==PuissanceSommeDesChiffres) {
        printf("puissance de la somme;%lld=(",nb);
        for(c=nbdeChiffres-1;c>=0;c--) {
          printf("%lld",Chiffre[c]); if(c!=0) { printf("+"); }
        }
        printf(")^%lld\n",d);
      }
      PuissanceSommeDesChiffres*=SommeDesChiffres;

      // Un nombre est gal  une puissance du produit de ses chiffres?
      if(nb==PuissanceProduitDesChiffres) {
        printf("puissance du produit;%lld=(",nb);
        for(c=nbdeChiffres-1;c>=0;c--) {
          printf("%lld",Chiffre[c]); if(c!=0) { printf("*"); }
        }
        printf(")^%lld\n",d);
      }
      PuissanceProduitDesChiffres*=ProduitDesChiffres;

      // Un nombre est gal  un multiple de la somme de ses chiffres?
      // 18=(1+8)*2
      // 45=(4+5)*5
      if(nb==MultipleSommeDesChiffres) {
        printf("multiple de la somme;%lld=(",nb);
        for(c=nbdeChiffres-1;c>=0;c--) {
          printf("%lld",Chiffre[c]); if(c!=0) { printf("+"); }
        }
        printf(")*%lld\n",d);
      }
      MultipleSommeDesChiffres+=SommeDesChiffres;

      // Un nombre est gal  un multiple du produit de ses chiffres?
      // 24=(2*4)*3
      // 1575=(1*5*7*5)*9
      if(nb==MultipleProduitDesChiffres) {
        printf("multiple du produit;%lld=(",nb);
        for(c=nbdeChiffres-1;c>=0;c--) {
          printf("%lld",Chiffre[c]); if(c!=0) { printf("*"); }
        }
        printf(")*%lld\n",d);
      }
      MultipleProduitDesChiffres+=ProduitDesChiffres;

    }

    //**** Le nombre est gal  la somme des puissances de ses chiffres? ****
    for(c=nbdeChiffres-1;c>=0;c--) { PuissanceDuChiffre[c]=1; }
    for(d=1;d<10;d++) {
      SommeDesPuissances=0;
      for(c=nbdeChiffres-1;c>=0;c--) {
        PuissanceDuChiffre[c]*=Chiffre[c];
        SommeDesPuissances+=PuissanceDuChiffre[c];
      }
      if(nb==SommeDesPuissances) {
        printf("somme des puissances;%lld=",nb);
        for(c=nbdeChiffres-1;c>=0;c--) {
          printf("%lld^%lld",Chiffre[c],d);
          if(c!=0) { printf("+"); }
        }
        printf("\n");
      }
    }

  } // next nb
  exit(0);
}
