// NumbersSortedByNumberOfBits.c

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()

//Output:
//#define MaxNbBits 6
//#define MaxNbBits_Power2 64
//ValuesWithNBits_Occurence[MaxNbBits+1]={1,6,15,20,15,6,1};
//ValuesWithNBits_Position[MaxNbBits+1]={0,1,7,22,42,57,63};
//ValuesWithNBits[MaxNbBits_Power2]={
//0,
//1,2,4,8,16,32,
//3,5,6,9,10,12,17,18,20,24,33,34,36,40,48,
//7,11,13,14,19,21,22,25,26,28,35,37,38,41,42,44,49,50,52,56,
//15,23,27,29,30,39,43,45,46,51,53,54,57,58,60,
//31,47,55,59,61,62,
//63
//};


//#define MaxNbBits 4
//#define MaxNbBits_Power2 16
//#define NbBits_Start 1
//#define NbBits_End 3
//#define ValuesWithNbBits_NbSets 3
//int ValuesWithNBits_Occurence[ValuesWithNbBits_NbSets]={4,6,4};
//int ValuesWithNBits_Position[ValuesWithNbBits_NbSets]={0,4,10};
//int ValuesWithNBits[14]={
//1,2,4,8,
//3,5,6,9,10,12,
//7,11,13,14
//};

#define MaxNbBits 5
#define MaxNbBits_Power2 32
#define NbBits_Start 0
#define NbBits_End 5
//#define ValuesWithNbBits_NbSets 4
//int ValuesWithNBits_Occurence[ValuesWithNbBits_NbSets]={5,10,10,5};
//int ValuesWithNBits_Position[ValuesWithNbBits_NbSets]={0,5,15,25};
//int ValuesWithNBits[30]={
//1,2,4,8,16,
//3,5,6,9,10,12,17,18,20,24,
//7,11,13,14,19,21,22,25,26,28,
//15,23,27,29,30
//};


//#define MaxNbBits 18
//#define MaxNbBits_Power2 262144
//#define NbBits_Start 4
//#define NbBits_End 11


int NbValuesWithNBits[MaxNbBits+1];
int RulesUsed[MaxNbBits_Power2],NbBitsSet[MaxNbBits_Power2];

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); // no buffering for output!

  int c,d,t,minpos,minnb,minval;
  int NbBits,position,TotalNbValues;

  for(c=0;c<=MaxNbBits;c++) {
    NbValuesWithNBits[c]=0;
  }

  //count the number of bits set
  for(c=0;c<MaxNbBits_Power2;c++) {
    RulesUsed[c]=c;
    NbBits=0;
    for(d=0;d<MaxNbBits;d++) {
      if((c & (1<<d))!=0) { NbBits++; }
    }
    NbBitsSet[c]=NbBits;
    NbValuesWithNBits[NbBits]=NbValuesWithNBits[NbBits]+1;
  }

  // sort by increasing number of bits sets
  for(c=0;c<MaxNbBits_Power2-1;c++) {
    minnb=NbBitsSet[c];
    minpos=c;
    minval=RulesUsed[c];
    for(d=c+1;d<MaxNbBits_Power2;d++) {
      if((NbBitsSet[d]<minnb) || ((NbBitsSet[d]==minnb) && (RulesUsed[d]<minval))) {
//      if(NbBitsSet[d]<=minnb) {
        minnb=NbBitsSet[d];
        minpos=d;
        minval=RulesUsed[d];
      }
    }
    //exchange
    t=NbBitsSet[c];
    NbBitsSet[c]=NbBitsSet[minpos];
    NbBitsSet[minpos]=t;
    t=RulesUsed[c];
    RulesUsed[c]=RulesUsed[minpos];
    RulesUsed[minpos]=t;
  }

  //show
  TotalNbValues=0;
  printf("#define ValuesWithNbBits_NbSets %d\n",NbBits_End-NbBits_Start+1);
  printf("int ValuesWithNBits_Occurence[ValuesWithNbBits_NbSets]={");
  for(c=NbBits_Start;c<=NbBits_End;c++) {
    printf("%d",NbValuesWithNBits[c]);
    if(c!=NbBits_End) { printf(","); }
    TotalNbValues+=NbValuesWithNBits[c];
  }
  printf("};\n");
  printf("int ValuesWithNBits_Position[ValuesWithNbBits_NbSets]={");
  position=0;
  for(c=NbBits_Start;c<=NbBits_End;c++) {
    printf("%d",position);
    if(c!=NbBits_End) { printf(","); }
    position=position+NbValuesWithNBits[c];
  }
  printf("};\n");

  printf("int ValuesWithNBits[%d]={\n",TotalNbValues);
  position=0;
  for(c=0;c<=MaxNbBits;c++) {
    for(d=0;d<NbValuesWithNBits[c];d++) {
      if((c>=NbBits_Start) && (c<=NbBits_End)) {
        printf("%d",RulesUsed[position]);
        if((c!=NbBits_End) || (d!=NbValuesWithNBits[c]-1)) { printf(","); }
      }
      position++;
    }
    if((c>=NbBits_Start) && (c<=NbBits_End)) {
      printf("\n");
    }
  }
  printf("};\n");

  exit(0);
}

