// shell.c
// Alain Brobecker -
#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define TRUE 1
#define FALSE 0


//**** GCD ****
int gcd(p,q) int p,q; {
  int r;
  if((r=p%q)==0) {
    return q;
  } else {
    return(gcd(q,r));
  }
}

//**** LCM ****
int lcm(p,q) int p,q; { return(p*q/gcd(p,q)); }

//!!! SEE ALSO nCk_Generate
//**** nCk ****
//                               n*(n-1)*...*(k+1)
//Returns nCk=n!/(k!*(n-k)!) = ---------------------
//                              (n-k)*(n-k-1)*...*1
//But n*(n-1)*...*(k+1)=(n-k+k)*...*(1+k)  also has n-k factors.
int nCk(int N, int K) {
  int t,p,q,d;
  p=1;
  q=1;
  for(t=0;t<N-K;t++) {
    p=p*(N-t);
    q=q*(t+1);
    d=gcd(p,q);
    p=p/d;
    q=q/d;
//    printf("%d/%d\n",p,q);
  }
  return(p); //we know that p/q is an integer
}

//**** FACTORIAL ****
int factorial(int n) {
 if(n==0) {
   return(1);
 } else {
   return(n*factorial(n-1));
 }
}

//**** ISPRIME ****
int IsPrime(int p) {
  int d;
  if(p<2) { return(FALSE); }
  if(p==2) { return(TRUE); }
  if((p%2)==0) { return(FALSE); }
  for(d=3;d<p;d=d+2) { if((p%d)==0) { return(FALSE); } }
  return(TRUE);
}

//**** MIN ****
int min(int val1,int val2) {
  if(val1<=val2) {
    return(val2);
  } else {
    return(val1);
  }
}

//**** MAX ****
int max(int val1,int val2) {
  if(val1>=val2) {
    return(val2);
  } else {
    return(val1);
  }
}

//**** POWER ****
// returns 0 if n<0
int Power(int x,int n) {
  if(n>0) {
    return (x*Power(x,n-1));
  } else if ((n==0) && (x!=0)) {
    return (1);
  } else {
    return (0);
  }
}

//**** From D.E.Knuth's Art of Computer Programming, vol.2, p185 ****
//**** period of pseudorandom sequence is 2147483646             ****
#define rndM 2147483647 /* 2^31-1, a Mersenne prime */
#define rndA 48271      /* this does well in the spectral test */
#define rndQ 44488      /* rndM/rndA */
#define rndR 3399       /* rndM%rndA, it's important that rndR<rndQ */
long rndX=1;            /* should be initialised to 0<rndX<rndM */
void rndNext() {
  rndX=rndA*(rndX%rndQ)-rndR*(long)(rndX/rndQ); /* X=AX mod M */
  if(rndX<0) {rndX+=rndM; }
}

//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

//**** MAIN ****
int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); // no buffering for output!

  //Read from command line
  if(argc<=2) { printf("Usage: %s Width Height\n",argv[0]); exit(1); }
  Width=ReadNumber(argv[1]);
  Height=ReadNumber(argv[2]);

  exit(0);
}
