/* Read a .BMP file, change color channel and save as .BMP */ 
/* Florian & Alain 2008/12/21 */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

/* Global variables */
int ImgLength;
int ImgPos;
unsigned char *Img;

int ReadLongWord (int pos) {
    int Value;
    if(pos+3>=ImgLength) {printf("error: cannot read long word\n"); exit(1);}
    Value=((Img[pos+3]*256+Img[pos+2])*256+Img[pos+1])*256+Img[pos];
    return Value;   
}

int ReadWord (int pos) {
    int Value;
    if(pos+1>=ImgLength) {printf("error: cannot read word\n"); exit(1);}
    Value=Img[pos+1]*256+Img[pos];
    return Value;   
}

/***************************************************************************/
int main(argc,argv) int argc; char *argv[]; {

  FILE *filep,*fopen(const char *,const char *);
  int Width, Height;
  int pos,c,t;
  
  if(argc!=3) { printf("usage: %s infile outfile\n",argv[0]); exit(1); }
  /* LOAD FILE */
  filep=fopen(argv[1],"rb"); /* rb = read binary */
  if(filep==0) { printf("error: file not found\n"); exit(1); }
  fseek(filep,0,2); /* set the file pointer at the end of file */
  ImgLength=(int) ftell(filep); /* returns the length of the file */
  fseek(filep,0,0); /* set the file pointer at the start of file */
  Img=(unsigned char *) malloc((unsigned int) ImgLength); /* allocate memory */
  fread(Img,1,ImgLength,filep); /* load file, 1=size of a byte */
  fclose(filep);

  if(ImgLength<54){printf("error: must be >54 bytes\n"); exit(1); }
  if((Img[0]!='B') || (Img[1]!='M')) {printf("error: not a .bmp file\n"); exit(1); }
  if(ImgLength!=ReadLongWord(2)){printf("error: file corrupted!\n"); exit(1); }
 
  Width=ReadLongWord(18);
  Height=ReadLongWord(22);
  printf("image is %d x %d\n",Width,Height);
  if(ReadWord(28)!=24){printf("error: not a 24 bbp image\n"); exit(1); };
  pos=ReadLongWord(10);
  if(pos+3*Width*Height>ImgLength){printf("error: file corrupted!\n"); exit(1);};
  for(c=0;c<Width*Height;c++){
     t=Img[pos+c*3+0];
     Img[pos+c*3+0]=Img[pos+c*3+1];
     Img[pos+c*3+1]=Img[pos+c*3+2];
     Img[pos+c*3+2]=t;
  }
  /* save file */
  filep=fopen(argv[2],"wb"); /* write binary */
  fwrite(Img,1,ImgLength,filep);
  fclose(filep);
}
