/* Frederic Elisei */
#define MAX_SIZE 20
#define MAX_STR 200

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char grid[MAX_SIZE][MAX_SIZE];
char canbe[MAX_SIZE][MAX_SIZE];

int WIDTH=0, HEIGHT=0;
int NB_MISS=0;
int NB_LEFT=0;

int CNT_REC_LEFT=0;
int CNT_REC_FREE=0;

void read_grid(char *filename) {
  FILE *fid;
  char tmp[MAX_STR];
  int i,j;

  fid=fopen(filename,"rt");
  // But & Dimensions :
  fgets(tmp,MAX_STR,fid);
  sscanf(tmp,"%dx%d %d",&WIDTH,&HEIGHT,&NB_MISS);
  for(i=0;i<=WIDTH+1;i++){
	grid[0][i]=grid[1+HEIGHT][i]='#';
    canbe[0][i]=canbe[1+HEIGHT][i]=0;
  }
  for(j=1;j<=HEIGHT;j++) {
	fgets(tmp,MAX_STR,fid);
	if (tmp[0]&&(tmp[strlen(tmp)-1]=='\n')) tmp[strlen(tmp)-1]=' ';
	for(i=strlen(tmp);i<WIDTH;i++)
	  tmp[i]=' ';
	grid[j][0]='#';canbe[j][0]=0;
	for(i=1;i<=WIDTH;i++) {
	  canbe[j][i]=1;
	  grid[j][i]=tmp[i-1];
	  NB_LEFT+=(tmp[i-1]=='@');
	}
	grid[j][WIDTH+1]='#';canbe[j][WIDTH+1]=0;
  }
  fclose(fid);
}

void print_grid() {
  int i,j;

  printf("#");
  for(i=1;i<=WIDTH;i++) printf("###");
  printf("#\n");
  for(j=1;j<=HEIGHT;j++) {
	printf("#");
	for(i=1;i<=WIDTH;i++) printf("%c%c%c",((grid[j][i-1]=='+')||(grid[j][i]=='+'))?'-':' ',(grid[j][i]==' ')?'.':((grid[j][i]=='|')?'+':grid[j][i]),((grid[j][i+1]=='+')||(grid[j][i]=='+'))?'-':' ');
	printf("#\n#");
    for(i=1;i<=WIDTH;i++) printf(" %c ",((grid[j+1][i]=='|')||(grid[j][i]=='|'))?'|':' ');
	printf("#\n");
  }
  printf("#");
  for(i=1;i<=WIDTH;i++) printf("###");
  printf("#\n");
}

void print_canbe() {
  int i,j;

  printf("\n");
  for(j=0;j<=HEIGHT+1;j++) {
	for(i=0;i<=WIDTH+1;i++) printf("%c",(canbe[j][i]==0)?'X':'?');
	printf("\n");
  }
}


// On joue les coups surs, sans pouvoir revenir en arriere :
int fill_grid() {
  int i,j;
  int linked;
  int canbeHP, canbeHM, canbeVP, canbeVM;
  int modified=0;

  for(j=1;j<=HEIGHT;j++) {
	for(i=1;i<=WIDTH;i++) {
	  // On a une extremite ?
	  if (grid[j][i]=='@') {
		linked=(grid[j][i-1]=='+')||(grid[j][i+1]=='+');
		linked|=(grid[j+1][i]=='|')||(grid[j-1][i]=='|');
		// On n'est pas encore lie ?
		if (!linked) {
		  canbeHP=(grid[j][i+1]==' ')&&canbe[j][i+2];
		  canbeHM=(grid[j][i-1]==' ')&&canbe[j][i-2];
		  canbeVP=(grid[j+1][i]==' ')&&canbe[j+2][i];
		  canbeVM=(grid[j-1][i]==' ')&&canbe[j-2][i];
		  // Une seule possibilitee ?
		  if (canbeHP+canbeHM+canbeVP+canbeVM==1) {
			if (canbeHP) {NB_LEFT-=(grid[j][i+2]=='@')+1;grid[j][i+1]='+';if (grid[j][i+2]==' ') grid[j][i+2]='O';canbe[j][i]=canbe[j][i+1]=canbe[j][i+2]=0; }
			if (canbeHM) {NB_LEFT-=(grid[j][i-2]=='@')+1;grid[j][i-1]='+';if (grid[j][i-2]==' ') grid[j][i-2]='O';canbe[j][i]=canbe[j][i-1]=canbe[j][i-2]=0; }
			if (canbeVP) {NB_LEFT-=(grid[j+2][i]=='@')+1;grid[j+1][i]='|';if (grid[j+2][i]==' ') grid[j+2][i]='O';canbe[j][i]=canbe[j+1][i]=canbe[j+2][i]=0; }
			if (canbeVM) {NB_LEFT-=(grid[j-2][i]=='@')+1;grid[j-1][i]='|';if (grid[j-2][i]==' ') grid[j-2][i]='O';canbe[j][i]=canbe[j-1][i]=canbe[j-2][i]=0; }
			// On valide !
			NB_MISS-=1;
//			print_grid();
			modified=1;
		  }
		}
	  }
	}
  }
  return modified;
}

// On explore les coups qui inventent une nouvelle haltere,
// jusqu'a trouver une combinaison finale gagnante :
int recurse_free(int nb_missing,int nb_left) {
  int i,j;
  char mem_av, mem_ap;

  // On a fini et la solution est acceptable ?
  if (nb_missing==0) {
	if (nb_left==0) {
	  printf("\nSolution apres exploration etendue (%d & %d appels) :\n",CNT_REC_LEFT,CNT_REC_FREE);
	  print_grid();
	}
	return(nb_left==0);
  }

  CNT_REC_FREE++;
  // On va visiter toutes les insertions possibles...
  for(j=1;j<=HEIGHT;j++) for(i=1;i<=WIDTH;i++) {

	  if (grid[j][i]==' ') {
		// Horizontale ?
		if (canbe[j][i-1]&&canbe[j][i+1]) {
		  mem_av=grid[j][i-1];mem_ap=grid[j][i+1];
		  canbe[j][i-1]=canbe[j][i]=canbe[j][i+1]=0;
		  grid[j][i]='+';grid[j][i+1]=grid[j][i-1]='O';
		  if (recurse_free(nb_missing-1,nb_left-(mem_av=='@')-(mem_ap=='@')))
			return(1);
		  else {
			grid[j][i-1]=mem_av;grid[j][i]=' ';grid[j][i+1]=mem_ap;
			canbe[j][i-1]=canbe[j][i]=canbe[j][i+1]=1;
		  }
		}
		// Verticale ?
		if (canbe[j-1][i]&&canbe[j+1][i]) {
		  mem_ap=grid[j+1][i];mem_av=grid[j-1][i];
		  grid[j][i]='|';grid[j+1][i]=grid[j-1][i]='O';
		  canbe[j-1][i]=canbe[j][i]=canbe[j+1][i]=0;
		  if (recurse_free(nb_missing-1,nb_left-(mem_av=='@')-(mem_ap=='@')))
			return(1);
		  else {
			grid[j-1][i]=mem_av;grid[j][i]=' ';grid[j+1][i]=mem_ap;
			canbe[j-1][i]=canbe[j][i]=canbe[j+1][i]=1;
		  }
		}
	  }
  }

  return(0);
}


// On explore les coups qui completent une haltere a moitie-visible,
// en commencant par les moins combinatoires,
// jusqu'a trouver directement une combinaison finale gagnante
// ou pouvoir appeler recurse_free() en bout d'arbre :
int recurse_left(int nb_missing,int nb_left) {
  int i,j;
  int canbeHP, canbeHM, canbeVP, canbeVM;
  int nb_free, min_free, min_i, min_j, min_combi;

  // Cas terminaux ?
  if ((nb_missing==0)&&(nb_left==0)) {
	printf("\nSolution apres exploration minimale (%d appels):\n",CNT_REC_LEFT);
	print_grid();
	return(1);
  } else if (nb_left==0)
	return(recurse_free(nb_missing,nb_left));

  CNT_REC_LEFT++;
  // Il y a au moins une extremite qui traine...
  min_free=5;
  for(j=1;j<=HEIGHT;j++) for(i=1;i<=WIDTH;i++) {
	  // On a une extremite pas encore liee ?
	  if ((grid[j][i]=='@')&&canbe[j][i]) {
		  canbeHP=(grid[j][i+1]==' ')&&canbe[j][i+2];
		  canbeHM=(grid[j][i-1]==' ')&&canbe[j][i-2];
		  canbeVP=(grid[j+1][i]==' ')&&canbe[j+2][i];
		  canbeVM=(grid[j-1][i]==' ')&&canbe[j-2][i];
		  if ((nb_free=canbeHP+canbeHM+canbeVP+canbeVM)<min_free) {
			min_free=nb_free;
			min_i=i;
			min_j=j;
			min_combi=canbeHP+(canbeHM<<1)+(canbeVP<<2)+(canbeVM<<3);
		  }
	  }
  }

  i=min_i;
  j=min_j;
  while (min_combi!=0) {
	int dv,dh;
	char prev;

    if (min_combi&1) {dh=1;dv=0;min_combi-=1;}
    else if (min_combi&2) {dh=-1;dv=0;min_combi-=2;}
    else if (min_combi&4) {dh=0;dv=1;min_combi-=4;}
    else if (min_combi&8) {dh=0;dv=-1;min_combi-=8;}

	if ((prev=grid[j+dv+dv][i+dh+dh])==' ')	grid[j+dv+dv][i+dh+dh]='O';
	grid[j+dv][i+dh]=(dh==0)?'|':'+';
	canbe[j][i]=canbe[j+dv][i+dh]=canbe[j+dv+dv][i+dh+dh]=0;
	if (recurse_left(nb_missing-1,nb_left-(prev=='@')-1))
	  return(1);
	else {
	  grid[j+dv][i+dh]=' ';
	  grid[j+dv+dv][i+dh+dh]=prev;
	  canbe[j][i]=canbe[j+dv][i+dh]=canbe[j+dv+dv][i+dh+dh]=1;
	}
  }

  return(0);
}

int main(int argc, char *argv[]) {

  if (argc!=2) {
	printf("Usage:\n  %s <filename>\n",argv[0]);
	exit(-1);
  }

  // Etat initial :
  read_grid(argv[1]);
  printf("Puzzle : %s\n",argv[1]);
  print_grid();
  printf("^^^ %d barre(s) manquante(s) + %d boule(s) restante(s).\n\n",NB_MISS,NB_LEFT);

  //  Remplissage simple :
  while ((NB_MISS>0)&&fill_grid());
  printf("Apres remplissage simple:\n");
  print_grid();
  printf("^^^ %d barre(s) manquante(s) + %d boule(s) restante(s).\n\n",NB_MISS,NB_LEFT);

  // Recursion sur les boules restantes ou sur les halteres manquantes :
  if (NB_LEFT>0) recurse_left(NB_MISS,NB_LEFT);
  else if (NB_MISS>0) recurse_free(NB_MISS,NB_LEFT);

  return(0);
}
