// hexdump.c dumps a file in hexa+ascii
// Alain Brobecker - 2011/08/23

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define TRUE 1
#define FALSE 0

void PrintByte(byte) unsigned char byte; { printf("%x%x ",(byte>>4)&15,byte&15); }

// show bytes from adress[start] to adress[end]
void HexDump(adress,start,end) unsigned char *adress; int start,end; {
  int c,d,NewLine;
  NewLine=0;
  for(c=start;c<=end;c++) {
    if(NewLine==0) { printf("%6x : ",c); }
    PrintByte(adress[c]);
    NewLine++;
    if((NewLine==16) || (c==end)) {
      NewLine=0;
      // ascii print
      for(d=c-15;d<=c;d++) {
        if(adress[d]>=32) { printf("%c",adress[d]); } else { printf("."); }
      }
      printf("\n");
    }
  }  
}

/***************************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  FILE *filep;
  int FileLength;
  unsigned char *File;

  if(argc!=2) { printf("usage: hexdump file\n"); exit(1); }
  
  // load file
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2);
  FileLength=(int) ftell(filep);
  fseek(filep,0,0);
  File=(unsigned char *) malloc((unsigned int) FileLength);
  fread(File,1,FileLength,filep);
  fclose(filep);
  printf("%s: %d bytes\n",argv[1],FileLength);

  //dump it
  HexDump(File,0,FileLength-1);
  
  exit(0);
}
