/* 10 august 2005 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/**** global variables */
unsigned char *Img,*ImgZoomed;
int ImgSize,ImgSize2,NbSteps,PosX,PosY;
struct NbPixels {
  int Set;
  int Total;
};

struct NbPixels CountPixels(a1,b1,a2,b2) double a1,b1,a2,b2; {
  int ia1,ib1,ia2,ib2,a,b;
  struct NbPixels nb;
  nb.Set=0;
  nb.Total=0;
  ia1=(int) a1;
  if(a1-(double)ia1>=0.5) { ia1++; }
  ib1=(int) b1;
  if(b1-(double)ib1>=0.5) { ib1++; }
  ia2=(int) a2;
  if(a2-(double)ia2>=0.5) { ia2++; }
  ib2=(int) b2;
  if(b2-(double)ib2>=0.5) { ib2++; }
  if((ia1!=ia2) && (ib1!=ib2)) {
    for(b=ib1;b<ib2;b++) {
      for(a=ia1;a<ia2;a++) {
        nb.Total++;
        if(Img[b*ImgSize+a]==255) { nb.Set++; }
      } /* next a */
    } /* next b */
  } /* endif */
  return (nb);
}

int main() {
  FILE *FilePtr;
  char *FileName;
  unsigned char Pixel;
  int Step,u,v,ix1,iy1,ix2,iy2;
  double Threshold,xLeft,xRight,yUp,yDown,x1,fx1,y1,fy1,x2,fx2,y2,fy2,NewSize;
  struct NbPixels nb1,nb2;
  /**** Zoom dependant values */
  PosX=31; PosY=31;
  NbSteps=100;
  /**** Set some values, allocate memory, load image, check (PosX,PosY) is set*/
  FileName="000.raw";
  FilePtr=fopen(FileName,"rb");
  if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
  fseek(FilePtr,0,2); ImgSize2=ftell(FilePtr); fseek(FilePtr,0,0);
  ImgSize=(int) sqrt((double) ImgSize2);
  Img=(char *) calloc((unsigned int) ImgSize2,1);
  ImgZoomed=(char *) calloc((unsigned int) ImgSize*ImgSize,1);
  fread(Img,1,ImgSize2,FilePtr);
  fclose(FilePtr);
  if(Img[PosY*ImgSize+PosX]!=255) {printf("error: (%d,%d) isn't set\n",PosX,PosY); exit(1); }
  /**** Get threshold value */
  nb1=CountPixels(0.0,0.0,(double) ImgSize,(double) ImgSize);
  Threshold=(double) nb1.Set/nb1.Total;
  
  /**** zoom routine */
  for(Step=1;Step<NbSteps;Step++) {
    NewSize=exp( log((double) ImgSize) * (1.0 - (double) Step/NbSteps));
    xLeft=(double) PosX +0.5 - (double)NewSize/2;
    xRight=(double) PosX + 0.5  + (double)NewSize/2;
    yUp=(double) PosY + 0.5 - (double)NewSize/2;
    yDown=(double) PosY + 0.5 + (double)NewSize/2;
    
    
/*    xLeft=0+Step*(double) (PosX-0)/NbSteps;
    yUp=0+Step*(double) (PosY-0)/NbSteps;
    xRight=ImgSize+Step*(double) (PosX+1-ImgSize)/NbSteps;
    yDown=ImgSize+Step*(double) (PosY+1-ImgSize)/NbSteps;
*//*!!!*/ printf("(%f,%f)->(%f,%f)\n",xLeft,yUp,xRight,yDown); 
    for(u=0;u<ImgSize;u++) {
      x1=xLeft+u*(xRight-xLeft)/ImgSize;
      ix1=(int) x1;
      fx1=(x1-(double)ix1)*ImgSize;
      x2=(double) xLeft+(u+1)*(xRight-xLeft)/ImgSize;
      ix2=(int) x2;
      fx2=(x2-(double)ix2)*ImgSize;
      for(v=0;v<ImgSize;v++) {
        Pixel=0;
        y1=(double) yUp+v*(yDown-yUp)/ImgSize;
        iy1=(int) y1;
        fy1=(y1-(double)iy1)*ImgSize;
        y2=(double) yUp+(v+1)*(yDown-yUp)/ImgSize;
        iy2=(int) y2;
        fy2=(y2-(double)iy2)*ImgSize;
        if(ix1==ix2) {
          if(iy1==iy2) {
            nb1=CountPixels(fx1,fy1,fx2,fy2);
            if(Img[iy1*ImgSize+ix1]==0) { nb1.Set=0; }
/*!!! printf("(%f,%f)->(%f,%f) : %d/%d\n",x1,y1,x2,y2,nb1.Set,nb1.Total); */
          } else {
            nb1=CountPixels(fx1,fy1,fx2,(double) ImgSize);
            if(Img[iy1*ImgSize+ix1]==0) { nb1.Set=0; }
            nb2=CountPixels(fx1,0.0,fx2,fy2);
            if(Img[iy2*ImgSize+ix1]==0) { nb2.Set=0; }
            nb1.Set=nb1.Set+nb2.Set;
            nb1.Total=nb1.Total+nb2.Total;
          }
        } else {
          if(iy1==iy2) {
            nb1=CountPixels(fx1,fy1,(double) ImgSize,fy2);
            if(Img[iy1*ImgSize+ix1]==0) { nb1.Set=0; }
            nb2=CountPixels(0.0,fy1,fx2,fy2);
            if(Img[iy1*ImgSize+ix2]==0) { nb2.Set=0; }
            nb1.Set=nb1.Set+nb2.Set;
            nb1.Total=nb1.Total+nb2.Total;
          } else {
            nb1=CountPixels(fx1,fy1,(double) ImgSize,(double) ImgSize);
            if(Img[iy1*ImgSize+ix1]==0) { nb1.Set=0; }
            nb2=CountPixels(fx1,0.0,(double) ImgSize,fy2);
            if(Img[iy2*ImgSize+ix1]==0) { nb2.Set=0; }
            nb1.Set=nb1.Set+nb2.Set;
            nb1.Total=nb1.Total+nb2.Total;
            nb2=CountPixels(0.0,fy1,fx2,(double) ImgSize);
            if(Img[iy1*ImgSize+ix2]==0) { nb2.Set=0; }
            nb1.Set=nb1.Set+nb2.Set;
            nb1.Total=nb1.Total+nb2.Total;
            nb2=CountPixels(0.0,0.0,fx2,fy2);
            if(Img[iy2*ImgSize+ix2]==0) { nb2.Set=0; }
            nb1.Set=nb1.Set+nb2.Set;
            nb1.Total=nb1.Total+nb2.Total;
          }
        }
        /* put pixel */
        if(nb1.Total!=0) {
          if((double)nb1.Set/nb1.Total>=Threshold) { Pixel=255; }
        }
        ImgZoomed[v*ImgSize+u]=Pixel;
      } /* next v */
    } /* next u */
    /* Save image */
    FileName[2]=FileName[2]+1;
    if(FileName[2]>'9') {
      FileName[1]=FileName[1]+1; FileName[2]='0';
      if(FileName[1]>'9') { FileName[0]=FileName[0]+1; FileName[1]='0'; }
    }
    FilePtr=fopen(FileName,"wb");
    if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
    fwrite(ImgZoomed,1,ImgSize2,FilePtr);
    fclose(FilePtr);
    
  } /* next Step */

  exit(0);
}

