/* GfxPacKer by baah/Arm's Tech - 2005aug23 */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define BPP 4    /* Bits Per Pixel */
#define BoxN 8   /* nb of bits used to store Boxes widths and heights */
#define BoxMax 255 /* 2^BoxN-1 */
#define ImgW 320
#define ImgH 200
#define ImgS 16    /* log2(ImgW*ImgH) */
#define TRUE 1
#define FALSE 0

struct Box {
  int x,y,w,h; /* x pos, y pox, width, height */
  unsigned char c; /* color */
};


int main() {
  FILE *FilePtr;
  char *FileName;
  unsigned char *Img2;
  short *Img;
  struct Box BestBox;
  int ImgSize,BoxSizeMin,Color,BestBoxSize,Size,BoxSize[BoxMax+1],NbBoxes;
  char BoxColor[BoxMax+1],stoph,stopw;
  int c,x,y,w,h; /* counters */
  /**** load file and convert pixels to shorts */
  ImgSize=ImgW*ImgH;
  FileName="bugs.raw";
  FilePtr=fopen(FileName,"rb");
  if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
  Img2=(char *) calloc((unsigned int) ImgSize,sizeof(unsigned char));
  fread(Img2,1,ImgSize,FilePtr);
  fclose(FilePtr);
  Img=(short *) calloc((unsigned int) ImgSize,sizeof(short));
  for(c=0;c<ImgSize;c++) { Img[c]=(short) Img2[c]; }
  
  /**** Find biggest boxes while it is profitable */
  BoxSizeMin=9; /* log2(ImgSize)/BPP + 2*BoxN/BPP + 1 */
  NbBoxes=0;
  do {
    BestBoxSize=BoxSizeMin;
    for(y=0;y<ImgH;y++) {
      for(x=0;x<ImgW;x++) {
        Color=Img[y*ImgW+x];
        for(c=0;c<=BoxMax;c++) { BoxSize[c]=0; BoxColor[c]=Color; }
        h=0;
        stoph=FALSE;
        do {
          c=Img[(y+h)*ImgW+x];
          if((c==BoxColor[0]) || (c==-1) || (BoxColor[0]==-1)) {
            w=0;
            stopw=FALSE;
            Size=0;
            do {
              if(BoxSize[w]>=0) {
                c=Img[(y+h)*ImgW+x+w];
                if((c==Color) || (c==-1) || (Color==-1)) {
                  if(Color==-1) { Color=c; }
                  if((Color==BoxColor[w]) || (Color==-1) || (BoxColor[w]==-1)) {
                    if(c!=-1) { Size++; }
                    BoxSize[w]=BoxSize[w]+Size;
/*!!! printf("(%d,%d) -> (%d,%d): %d\n",x,y,x+w,y+h,BoxSize[w]);*/
                    if(BoxSize[w]>BestBoxSize) {
                      BestBox.x=x;
                      BestBox.y=y;
                      BestBox.w=w;
                      BestBox.h=h;
                      BestBox.c=Color;
                      BestBoxSize=BoxSize[w];
                    } /* endif */
                  } else {
                    BoxSize[w]=-1;
                    stopw=TRUE;
                  } /* endif */
                } else {
                  BoxSize[w]=-1;
                  stopw=TRUE;
                } /* endif */
              } else {
                stopw=TRUE;
              } /*endif */
              w++;
            } while((w<=BoxMax) && (stopw!=TRUE) && (x+w<ImgW));
          } else {
            stoph=TRUE;
          }
          h++;
        } while((h<=BoxMax) && (stoph!=TRUE) && (y+h<ImgH));
      } /* next x */
    } /* next y */
    if(BestBoxSize!=BoxSizeMin) {
      NbBoxes++;
      x=BestBox.x;
      y=BestBox.y;
      printf("(%d,%d) -> (%d,%d): %d\n",x,y,x+BestBox.w,y+BestBox.h,BestBox.c);
      for(h=0;h<=BestBox.h;h++) {
        for(w=0;w<=BestBox.w;w++) {
          Img[(y+h)*ImgW+x+w]=-1;
        }
      }
    }
  } while(BestBoxSize!=BoxSizeMin);
  
  /**** Count number of pixels left */
  c=0;
  for(y=0;y<ImgH;y++) {
    for(x=0;x<ImgW;x++) {
      if(Img[y*ImgW+x]!=-1) { c++; }
    }
  }
  printf("%d pixels left\n",c);

  Size=c*BPP+NbBoxes*(ImgS+2*BoxN+BPP)+ImgS;
  printf("size will be: %.1f bytes (%d bits)\n",(float) Size/8.0,Size);
  
  exit(0);
}
