/* GfxPacKer by baah/Arm's Tech - 2005aug23 -> 25 */
/* !!! the w+h is in fact saved as a new position */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define BPP 4    /* Bits Per Pixel */
#define ImgW 320
#define ImgH 200
#define ImgS 16    /* log2(ImgW*ImgH) */
#define TRUE 1
#define FALSE 0

struct Box {
  int x,y,w,h; /* x pos, y pox, width, height */
  unsigned char c; /* color */
  struct Box *previous;
};

/* global variable */
unsigned char *Pk;


void PutNibble(position,nibble) int position,nibble; {
  int pos;
  unsigned char nib;
  pos=position>>1;
  nib=(unsigned char) nibble & 15;
  if((position & 1)==0) {
    Pk[pos]=(Pk[pos] & 240) | nib;
  } else {
    Pk[pos]=(Pk[pos] & 15) | (nib<<4);
  }
}



int main() {
  FILE *FilePtr;
  char *FileName;
  short *Img;
  struct Box BestBox,*PreviousBox,*NewBox;
  int ImgSize,BoxSizeMin,Color,BestBoxSize,Size,BoxSize[ImgW],NbBoxes;
  char BoxColor[ImgW],stoph,stopw;
  int c,x,y,w,h; /* counters */
  
  PreviousBox=NULL;
  /**** load file and convert pixels to shorts */
  ImgSize=ImgW*ImgH;
  FileName="bugs.raw";
  FilePtr=fopen(FileName,"rb");
  if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
  Pk=(unsigned char *) calloc((unsigned int) ImgSize,sizeof(unsigned char));
  fread(Pk,1,ImgSize,FilePtr);
  fclose(FilePtr);
  Img=(short *) calloc((unsigned int) ImgSize,sizeof(short));
  for(c=0;c<ImgSize;c++) { Img[c]=(short) Pk[c]; }
  
  /**** Find biggest boxes while it is profitable */
  BoxSizeMin=9; /* log2(ImgSize)/BPP + 2*BoxN/BPP + 1 */
  NbBoxes=0;
  do {
    BestBoxSize=BoxSizeMin;
    for(y=0;y<ImgH;y++) {
      for(x=0;x<ImgW;x++) {
        Color=Img[y*ImgW+x];
        for(c=0;c<ImgW;c++) { BoxSize[c]=0; BoxColor[c]=Color; }
        h=0;
        stoph=FALSE;
        do {
          c=Img[(y+h)*ImgW+x];
          if((c==BoxColor[0]) || (c==-1) || (BoxColor[0]==-1)) {
            w=0;
            stopw=FALSE;
            Size=0;
            do {
              if(BoxSize[w]>=0) {
                c=Img[(y+h)*ImgW+x+w];
                if((c==Color) || (c==-1) || (Color==-1)) {
                  if(Color==-1) { Color=c; }
                  if((Color==BoxColor[w]) || (Color==-1) || (BoxColor[w]==-1)) {
                    if(c!=-1) { Size++; }
                    BoxSize[w]=BoxSize[w]+Size;
/*!!! printf("(%d,%d) -> (%d,%d): %d\n",x,y,x+w,y+h,BoxSize[w]);*/
                    if(BoxSize[w]>BestBoxSize) {
                      BestBox.x=x;
                      BestBox.y=y;
                      BestBox.w=w;
                      BestBox.h=h;
                      BestBox.c=Color;
                      BestBoxSize=BoxSize[w];
                    } /* endif */
                  } else {
                    BoxSize[w]=-1;
                    stopw=TRUE;
                  } /* endif */
                } else {
                  BoxSize[w]=-1;
                  stopw=TRUE;
                } /* endif */
              } else {
                stopw=TRUE;
              } /*endif */
              w++;
            } while((stopw!=TRUE) && (x+w<ImgW));
          } else {
            stoph=TRUE;
          }
          h++;
        } while((stoph!=TRUE) && (y+h<ImgH));
      } /* next x */
    } /* next y */
    if(BestBoxSize!=BoxSizeMin) {
      NbBoxes++;
      x=BestBox.x;
      y=BestBox.y;
      printf("(%d,%d) -> (%d,%d): %d\n",x,y,x+BestBox.w,y+BestBox.h,BestBox.c);
      for(h=0;h<=BestBox.h;h++) {
        for(w=0;w<=BestBox.w;w++) {
          Img[(y+h)*ImgW+x+w]=-1;
        }
      }
      NewBox=(struct Box *) malloc(sizeof(struct Box));
      NewBox -> x=BestBox.x;
      NewBox -> y=BestBox.y;
      NewBox -> w=BestBox.w;
      NewBox -> h=BestBox.h;
      NewBox -> c=BestBox.c;
      NewBox -> previous=PreviousBox;
      PreviousBox=NewBox;
    }
  } while(BestBoxSize!=BoxSizeMin);
  
  /**** save Boxes in reverse order */
  c=0;
  for(x=0;x<NbBoxes;x++) {
    y=(NewBox -> y)*ImgW+(NewBox -> x);
    PutNibble(c++,y);
    y=y>>4;
    PutNibble(c++,y);
    y=y>>4;
    PutNibble(c++,y);
    y=y>>4;
    PutNibble(c++,y);
    y=((NewBox-> y)+(NewBox -> h))*ImgW+(NewBox -> x)+(NewBox -> w);
    PutNibble(c++,y);
    y=y>>4;
    PutNibble(c++,y);
    y=y>>4;
    PutNibble(c++,y);
    y=y>>4;
    PutNibble(c++,y);
    PutNibble(c++,NewBox -> c);
    NewBox=NewBox -> previous;
  }
  /**** put escape character for end of boxes */
  /*!!! on ST the escape char is $ff, otherwise we can use ImgH*ImgW-1,
    !!! since no box will ever start on this pixel */
  PutNibble(c++,15);
  PutNibble(c++,15);
  /**** Count number of pixels left and copy them */
  Size=0;
  for(y=0;y<ImgH;y++) {
    for(x=0;x<ImgW;x++) {
      if(Img[y*ImgW+x]!=-1) {
        PutNibble(c++,Img[y*ImgW+x]);
        Size++;
      }
    }
  }
  printf("%d pixels left\n",Size);

  Size=Size*BPP+NbBoxes*(2*ImgS+BPP)+8;
  printf("size will be: %.1f bytes (%d bits)\n",(float) Size/8.0,Size);
  
  /**** save resulting file */
  FilePtr=fopen("bugs.pk","wb");
  if(FilePtr==0) { printf("error: cannot save\n"); exit(1); }
  fwrite(Pk,1,(c+1)>>1,FilePtr);
  fclose(FilePtr);
  
  exit(0);
}
