/* 2005aug25 */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define ImgW 320
#define ImgH 200
#define TRUE 1
#define FALSE 0

/* global variable */
unsigned char *Pk;

int getnibble(position) int position; {
  int pos2,nib;
  pos2=position>>1;
  if((position & 1)!=0) {
    nib=Pk[pos2] & 15;
  } else {
    nib=Pk[pos2] >>4;
  }
  return (nib);
}

int main() {
  FILE *FilePtr;
  char *FileName;
  unsigned char Img[ImgW*ImgH],Done[ImgW*ImgH];
  unsigned char color;
  int adress,pos,x1,y1,x2,y2,x,y,PkLength,quit;  
  int NbPixelsOverlaping,NbBoxesOverlaping,BoxOverlaps;

  /**** load packed file */  
  FileName="weerdo.pk";
  FilePtr=fopen(FileName,"rb");
  if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
  fseek(FilePtr,0,2); /* 2 for EOF */
  PkLength=(int) ftell(FilePtr);
  fseek(FilePtr,0,0); /* 0 for SOF */
  Pk=(unsigned char *) calloc((unsigned int) PkLength,sizeof(unsigned char));
  fread(Pk,1,PkLength,FilePtr);
  fclose(FilePtr);

  /**** depack file */
  for(x=0;x<ImgW*ImgH;x++) { Img[x]=17; Done[x]=FALSE; }
  quit=FALSE;
  NbBoxesOverlaping=0;
  NbPixelsOverlaping=0;
  pos=0;
  do {
    adress=getnibble(pos++);
    adress=(adress<<4)+getnibble(pos++);
    if(adress==255) {
      quit=TRUE;
    } else {
      adress=(adress<<4)+getnibble(pos++);
      adress=(adress<<4)+getnibble(pos++);
      y1=(adress/ImgW);
      x1=adress-y1*ImgW;
      adress=getnibble(pos++);
      adress=(adress<<4)+getnibble(pos++);
      adress=(adress<<4)+getnibble(pos++);
      adress=(adress<<4)+getnibble(pos++);
      y2=(adress/ImgW);
      x2=adress-y2*ImgW;
      color=getnibble(pos++);
      printf("(%d,%d) -> (%d,%d) : %d\n",x1,y1,x2,y2,color);
      BoxOverlaps=FALSE;
      for(y=y1;y<=y2;y++) {
        for(x=x1;x<=x2;x++) {
          if((Done[y*ImgW+x]==TRUE) && (Img[y*ImgW+x]!=color)) {
            BoxOverlaps=TRUE;
            NbPixelsOverlaping++;
          }        
          Img[y*ImgW+x]=color;
          Done[y*ImgW+x]=TRUE;
        }
      }
      if(BoxOverlaps==TRUE) { NbBoxesOverlaping++; }
    } /* endif */
  } while(quit!=TRUE);
  printf("%d different colored boxes overlaping (%d pixels)\n",NbBoxesOverlaping,NbPixelsOverlaping);
  
  /**** residual pixels */
  for(x=0;x<ImgW*ImgH;x++) {
    if(Done[x]==FALSE) {
      Img[x]=getnibble(pos++);
    }
  }

  /**** save */
  FilePtr=fopen("weerdod.raw","wb");
  if(FilePtr==0) { printf("error: cannot save\n"); exit(1); }
  fwrite(Img,1,ImgW*ImgH,FilePtr);
  fclose(FilePtr);
   
  exit(0);
}
