/* Alain Brobecker, may 2007 */
/* Multiple ReMove */

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define FALSE           0
#define TRUE            1

FILE *filep;
unsigned char *Table,*In,*Out; /* data */
int TableLength,InLength,OutLength;
int TablePos;

/**** SearchNext routine, brute force version ******************************/
/* To speed up this routine, copy beforehand the string to search at the   */
/* end of the text (you must allocate a bit more memory) and remove the    */
/* TextPos+StringLength<=TextLength condition in main loop. The routine    */
/* will always find a string, once this is done, compare Pos+Length and    */
/* return -1 if it is the one we added!                                    */
int SearchNext(unsigned char *String,int StringLength,
               unsigned char *Text,int TextLength,int TextPos) {
  int NbMatch=0;
  while((NbMatch<StringLength) && (TextPos+StringLength<=TextLength)) {
    if(Text[TextPos+NbMatch]==String[NbMatch]) {
      NbMatch++;
    } else {
      NbMatch=0;
      TextPos++;
    }
  }
  if(NbMatch==StringLength) {
    return(TextPos);
  } else {
    return(-1);
  }
}

/**** Remove routine *******************************************************/
/* Returns new length */
int Remove(unsigned char *Text,int TextLength,int StartPos, int EndPos) {
  int c;
  if((StartPos==-1) || (EndPos==-1)) { return(TextLength); }
  if(StartPos>TextLength) { return(-1); }
  if(StartPos>EndPos) { return(-1); }
  if(EndPos>TextLength) { EndPos=TextLength; }
  for(c=0;c<TextLength-EndPos+1;c++) {
    Text[StartPos+c]=Text[EndPos+c];
  }      
  return(TextLength-(EndPos-StartPos));
}

/**** Main *****************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  int StartPos,EndPos;

  if(argc!=3) { printf("usage: MRM InFile OutFile\n"); exit(1); }

  /**** load File ****/
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); /* 2 for EOF */
  InLength=(int) ftell(filep);
  fseek(filep,0,0); /* 0 for SOF */
  In=(unsigned char *) malloc((unsigned int) InLength+10);
  fread(In,1,InLength,filep);
  fclose(filep);
  
/*  In[InLength]=0;*/ /*!!! printf bugs without null chart at end of string */
  
/*  printf("%d:%s\n",InLength,In);*/
  StartPos=SearchNext((unsigned char *) "<tr>",4,In,InLength,0);
  StartPos=SearchNext((unsigned char *) "<tr>",4,In,InLength,StartPos+1);
  while(StartPos!=-1) {
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*place*/
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*nom*/
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*Elo*/
    EndPos=SearchNext((unsigned char *) "</td>",5,In,InLength,StartPos+1);
    EndPos=SearchNext((unsigned char *) "</td>",5,In,InLength,EndPos+1);
    EndPos=SearchNext((unsigned char *) "</td>",5,In,InLength,EndPos+1);
    EndPos=SearchNext((unsigned char *) "</td>",5,In,InLength,EndPos+1);
    InLength=Remove(In,InLength,StartPos,EndPos+5);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*r1*/
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1);
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*Cum.*/
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*Sol.*/
    StartPos=SearchNext((unsigned char *) "<td",3,In,InLength,StartPos+1); /*Har.*/
    EndPos=SearchNext((unsigned char *) "</tr>",5,In,InLength,StartPos+1);
    InLength=Remove(In,InLength,StartPos,EndPos);
    StartPos=SearchNext((unsigned char *) "<tr>",4,In,InLength,StartPos+1);
}  
  
  
  
/*  EndPos=SearchNext((unsigned char *) "b",1,In,InLength,StartPos);
  InLength=Remove(In,InLength,StartPos,EndPos+1);*/
/*  printf("%d:%s\n",InLength,In); */
  
  /**** save resulting file ****/
  filep=fopen(argv[2],"wb");
  fwrite(In,1,InLength,filep);
  fclose(filep);
  exit(0);
}
