// Show combinations of K elements amongst N
// Alain Brobecker - 2010/02/12
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

//Returns greatest common divisor of two numbers
int pgcd(p,q) int p,q; {
  int r;
  if((r=p%q)==0) {
    return q;
  } else {
    return(pgcd(q,r));
  }
}

//                               n*(n-1)*...*(k+1)
//Returns nCk=n!/(k!*(n-k)!) = ---------------------
//                              (n-k)*(n-k-1)*...*1
//But n*(n-1)*...*(k+1)=(n-k+k)*...*(1+k)  also has n-k factors.
int nCk(int N, int K) {
  int t,p,q,d;
  p=1;
  q=1;
  for(t=0;t<N-K;t++) {
    p=p*(N-t);
    q=q*(t+1);
    d=pgcd(p,q);
    p=p/d;
    q=q/d;
//    printf("%d/%d\n",p,q);
  }
  return(p); //we know that p/q is an integer
}


/**** ReadNumber ****/
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */
  int comb_N;
  int comb_K;

  //read parameters from command line
  if(argc!=3) { printf("Usage: combinations N P\n"); exit(1); }
  comb_N=ReadNumber(argv[1]);
  comb_K=ReadNumber(argv[2]);
  printf("nCk(%d;%d)=%d\n",comb_N,comb_K,nCk(comb_N,comb_K));
  exit(0);
}
