// numberstudy.c - Alain Brobecker, 2011oct31
// !!! Pour ceux qui n'ont pas de decomposition en 3 termes ou plus, il
// !!! semble qu'a partir d'un certain rang on tombe sur les nombres premiers!
// (0,1,2,3,4,5,7,8,) 11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#include <math.h>

#define TRUE 1
#define FALSE 0

int IsPrime(int p) {
  int d;
  if(p<2) { return(FALSE); }
  if(p==2) { return(TRUE); }
  if((p%2)==0) { return(FALSE); }
  for(d=3;d<p;d=d+2) { if((p%d)==0) { return(FALSE); } }
  return(TRUE);
}

int SearchRegularSum(int Value) {
  int NbSolutions=0;
  int Start,Inc,N,MaxStart,MaxInc,MaxN,k;
  int Sum;
  int FirstValue=TRUE;

  MaxStart=(Value-1)/2;
  MaxInc=Value;
  MaxN=(int) sqrt((double) 2*Value);

  if((MaxStart>=1) && (MaxInc>=1) && (MaxN>=2)) {
    for(Start=1;Start<=MaxStart;Start++) {
      for(Inc=1;Inc<=MaxInc;Inc++) {
        for(N=2;N<=MaxN;N++) {
          Sum=(N+1)*Start+Inc*N*(N+1)/2;
          if(Sum==Value) {
            if(FirstValue==FALSE) { printf("  "); } else { FirstValue=FALSE; }
            printf("=%d",Start);
            for(k=1;k<=N;k++) { printf("+%d",Start+k*Inc); }
            NbSolutions++;
            printf("\n");
          }
        } //next N
      } //next Inc
    } //next Start
  }
  return (NbSolutions);
}

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); //no buffering for output!
  int c;

  for(c=2016;c<2100;c++) {
    printf("%d",c);
    if(IsPrime(c)==TRUE) { printf(" is prime "); }
    SearchRegularSum(c);
    printf("\n");
  }

  exit(0);
}
