// numberstudy.c - Alain Brobecker, 2011oct31
// !!! Pour ceux qui n'ont pas de decomposition en 3 termes ou plus, il
// !!! semble qu'a partir d'un certain rang on tombe sur les nombres premiers!
// (0,1,2,3,4,5,7,8,) 11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#include <math.h>

#define TRUE 1
#define FALSE 0

int IsPrime(int p) {
  int d,s;
  if((p%2)==0) { return(FALSE); }
  s=sqrt(p);
  for(d=3;d<p;d=d+2) { if((p%d)==0) { return(FALSE); } }
  return(TRUE);
}

int SearchRegularSum(int Value) {
  int NbSolutions=0;
  int Start,Inc,N,MaxStart,MaxInc,MaxN,k;
  int Sum;
  
  MaxStart=(Value-1)/2;
  MaxInc=Value;
  MaxN=(int) sqrt((double) 2*Value);

  if((MaxStart>=1) && (MaxInc>=1) && (MaxN>=2)) {  
    for(Start=1;Start<=MaxStart;Start++) {
      for(Inc=1;Inc<=MaxInc;Inc++) {
        for(N=2;N<=MaxN;N++) {
          Sum=(N+1)*Start+Inc*N*(N+1)/2;
          if(Sum==Value) {
//            printf("=%d",Start);
//            for(k=1;k<=N;k++) { printf("+%d",Start+k*Inc); }
            NbSolutions++;
          }
        } //next N
      } //next Inc
    } //next Start
  }
  return (NbSolutions);
}

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); //no buffering for output!
  int c;
  
  printf("Number without decompositions (* for non primes)\n");
  for(c=0;c<999;c++) {
    if((SearchRegularSum(c)==0)) {
      printf(",%d",c);
      if(IsPrime(c)==FALSE) { printf("*"); }
    }
  }

  printf("\n\nNumber with decompositions (* for primes)\n");
  for(c=0;c<999;c++) {
    if((SearchRegularSum(c)!=0)) {
      printf(",%d",c);
      if(IsPrime(c)==TRUE) { printf("*"); }
    }
  }
 
  exit(0);
}
