//***************************************************************************
//* Recursively lists all possible permutations of nb elts. For every depth *
//* we go through 0..nb-1, & if the value has not yet been used, we put it  *
//* in the list, and go on depth+1.                                         *
//******************************************************* Alain Brobecker ***

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define NbMax 16
int list[NbMax],used[NbMax];
int NbPermutations,nb;

//**** PERMUTE ****
void permute(int depth) {
int c,d;
  if(depth==nb) {
    printf("{");
    for(d=0;d<nb;d++) { printf("%d",list[d]); if(d!=nb-1) { printf(","); }}
    printf("},\n");
    NbPermutations++;
  } else {
    for(c=0;c<nb;c++) {
      if(used[c]==0) {
        list[depth]=c;
        used[c]=1;
        permute(depth+1);
        used[c]=0;
      }
    }
  }
}

//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

//**** MAIN ****
int main(argc,argv) int argc; char *argv[]; {
  int c;
  if(argc<=1) { printf("Usage: permute N\n"); exit(1); }
  nb=ReadNumber(argv[1]);
  for(c=0;c<nb;c++) { used[c]=0; }
  NbPermutations=0;
  permute(0);
  printf("%d!=%d permutations of %d elements.\n",nb,NbPermutations,nb);
  exit(0);
}
