// pgcd_binary.c - Alain Brobecker, 20140210
#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()

#define nmax 20

int pgcd_binary2(p,q) int p,q; {
  int k,w;
  //Find power of 2
  k=0;
  while(((p|q) & 1)==0) {
    k++;
    p=p>>1;
    q=q>>1;
  }
  //p or q is odd
  do{
    if((p&1)==0) {
      p=p>>1;
    } else {
      if((q&1)==0) {
        q=q>>1;
      } else {
        //p and q are odd
        w=p-q; //even
        if(w==0) {
          return(p << k); //end!
        }
        if(w<0) {
          w=-w;
          q=p;
        }
        p=w;
      }
    }
  } while(0==0);
}




// Binary algorithm by R.P.Brent and H.T.Kung
int pgcd_binary(p,q) int p,q; {
  int k,c,w;
  //Find power of 2
  k=0;
  while(((p|q) & 1)==0) {
    k++;
    p=p>>1;
    q=q>>1;
  }
  //Make sure u is odd
  if((p & 1)==0) {
    w=p;
    p=q;
    q=w;
  }
  //Initialize
  c=0;
  while(q!=0) {
    //increment c until v is odd
    while((q&1)==0) {
      q=q/2;
      c++;
    }
    if(c>0) {
      w=p;
      p=q;
      q=w;
      c=-c;
    }
    //reduce
    w=(p+q)/2;
    if((w&1)==0) {
      q=w;
    } else {
      q=w-q; //q=(p-q)/2
    }
  }

  //results is |u|*2^k
  if(p<0) { p=-p; }
  return(p << k);
}


//iterative Euclidian algorithm
int pgcd_iterative(p,q) int p,q; {
  int r;
  while((r=p%q)!=0) {
    p=q;
    q=r;
  }
  return(q);
}

//recursive Euclidian algorithm
int pgcd(p,q) int p,q; {
  int r;
  if((r=p%q)==0) {
    return(q);
  } else {
    return(pgcd(q,r));
  }
}

int ppcm(p,q) int p,q; { return(p*q/pgcd_binary2(p,q)); }

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */

  int ordre[nmax+1];
  int n,e,a,b;

  /* on se place dans (Z/nZ,+) */
  for(n=2;n<nmax+1;n++) {
    printf("Dans (Z/%dZ,+)\n",n);
    /* calcule l'ordre de chaque lment */
    for(e=0;e<n;e++) {
      ordre[e]=1;
      while((e*ordre[e]%n)!=0) {
        ordre[e]++;
      }
      printf(" ordre[%d]=%d\n",e,ordre[e]);
    }
    /* pour tout (a;b) regarder si ordre[a+b]<ppcm(ordre[a],ordre[b]) */
    a=0;
    while(a<n) {
      b=0;
      while((b<=a) && (a+b<n)) {
        if(ordre[a+b]<ppcm(ordre[a],ordre[b])) {
          printf("  ordre[%d+%d]=%d < ppcm(ordre[%d],ordre[%d])=ppcm(%d,%d)=%d\n",a,b,ordre[a+b],a,b,ordre[a],ordre[b],ppcm(ordre[a],ordre[b]));
        }
        b++;
      }
      a++;
    }



  }



  exit(0);
}
