// Alain Brobecker - 2009/10/10
// Search sets of pythagorean triples, with values of the
// first being contained in the others.
// Example: (45;60;75) -> (27;36;45) ... (32;60;68) (21;72;75) ...

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */
#include <math.h>

#define NbTriplesMax 1000

int main() {
  int Triplet[NbTriplesMax][3];
  int NbTriples=0;
  int m,n,p,mplusn,m2plusn2;
  int a,b,c;
  int i,j,found;
  
  // Start by searching and saving some pythagorean triples
  mplusn=2;
  while(NbTriples<NbTriplesMax) {
    m=1;
    n=mplusn-m;
    m2plusn2=1*1+n*n;
    while((m<n) && (NbTriples<NbTriplesMax)) {
      p=(int) sqrt(m2plusn2);
      if(p*p==m2plusn2) {
        Triplet[NbTriples][0]=m;
        Triplet[NbTriples][1]=n;
        Triplet[NbTriples][2]=p;
        NbTriples++;
//!!!        printf("(%d;%d;%d)\n",m,n,p);
      }
      m2plusn2+=2*(m-n+1);
      m++;
      n--;
    }
    mplusn++;
  }
  
  // For every pythagorean triple, look if its values are found
  // in others triples. In such case, print this triple and all
  // triples with a common value.
  for(i=0;i<NbTriples;i++) {
    m=Triplet[i][0];
    n=Triplet[i][1];
    p=Triplet[i][2];
    j=-1;
    found=0;
    do {
      j++; if(j==i) { j++; }
      a=Triplet[j][0];
      b=Triplet[j][1];
      c=Triplet[j][2];
      if((m==a) || (m==b) || (m==c)) { found=found | 1; }
      if((n==a) || (n==b) || (n==c)) { found=found | 2; }
      if((p==a) || (p==b) || (p==c)) { found=found | 4; }
    } while((j<NbTriples-1) && (found!=7));
    if(found==7) {
      printf("(%d;%d;%d) ->",m,n,p);
      j=-1;
      do {
        found=0;
        j++; if(j==i) { j++; }
        a=Triplet[j][0];
        b=Triplet[j][1];
        c=Triplet[j][2];
        if((m==a) || (m==b) || (m==c)) { found=found | 1; }
        if((n==a) || (n==b) || (n==c)) { found=found | 2; }
        if((p==a) || (p==b) || (p==c)) { found=found | 4; }
        if(found!=0) { printf(" (%d;%d;%d)",a,b,c); }
      } while((j<NbTriples-1) && (found!=7));
      printf("\n");
    }
  }
  return(0);
}
