#include <stdio.h>
#include <stdlib.h>

/**** From D.E.Knuth's Art of Computer Programming, vol.2, p185 ****/
/**** period of pseudorandom sequence is 2147483646             ****/
#define rndM 2147483647 /* 2^31-1, a Mersenne prime */
#define rndA 48271      /* this does well in the spectral test */
#define rndQ 44488      /* rndM/rndA */
#define rndR 3399       /* rndM%rndA, it's important that rndR<rndQ */
long rndX=1;            /* should be initialised to 0<rndX<rndM */
void rndNext() {
  rndX=rndA*(rndX%rndQ)-rndR*(long)(rndX/rndQ); /* X=AX mod M */
  if(rndX<0) {rndX+=rndM; }
}          

int main(argc,argv) int argc; char *argv[]; {
  long t=0;
  setbuf(stdout, NULL); /* no buffering for output! */
  rndNext();
  while (rndX!=1) {
    rndNext();
    t++;
    if((t & 1048575)==0) { printf("."); } 
  }
  printf("%d\n",t);
  exit(1);  
}
